#ifndef __vststudy__
#define __vststudy__

#include "../vst2.x/audioeffectx.h"

enum
{
	// Global
	kNumPrograms = 16,

	// Parameters Tags
	kDelay = 0, //!!! 
	kFeedBack,
	kOut,

	kNumParams
};

class VSTStudy;

//------------------------------------------------------------------------
class VSTStudyProgram
{
friend class VSTStudy;
public:
	VSTStudyProgram ();
	~VSTStudyProgram () {}

private:	
	float fDelay;
	float fFeedBack;
	float fOut;
	char name[24];
};

//------------------------------------------------------------------------
class VSTStudy : public AudioEffectX
{
public:
	VSTStudy (audioMasterCallback audioMaster);
	~VSTStudy ();

	//---from AudioEffect-----------------------
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);

	virtual void setProgram (VstInt32 program);
	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);
	virtual bool getProgramNameIndexed (VstInt32 category, VstInt32 index, char* text);
	
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual void resume ();

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { return kPlugCategEffect; }

protected:
	void setDelay (float delay); //!!! 

	VSTStudyProgram* programs;
	
	float* buffer;
	float fDelay;
	float fFeedBack;
	float fOut;
	
	long delay;
	long size;
	long cursor;
};

#endif
